#include <CapacitiveSensor.h>
#include <SoftwareSerial.h>
#include <Adafruit_NeoPixel.h>
#include <Vector.h>

typedef Vector<int> Elements;
int VECTOR_SIZE = 8;
int storage_array[8];
Elements vector;

int indAverage = 15;


//#define rx 3 //WE DONT NEED RX // we are u--------------------------------sing pin 3 to control LIGHTS
#define tx 4

int cap_pin_out = 2;
int cap_pin_in = 1;
int outputPin = 0;
CapacitiveSensor   capsense = CapacitiveSensor(cap_pin_out,cap_pin_in);   // 10M resistor between pins 4 & 2, pin 2 is sensor pin, add a wire and or foil if desired
SoftwareSerial serial(3, tx);

//now that we hvae set up software serial with pin 3, redefine RX pin as 3
#define LED_PIN 9
#define LED_COUNT 9

//declare the strip object

int averageTotal = 0;
int averageCalculated = 0;
int counter = 0;

Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);
// NEO_GRB     Pixels are wired for GRB bitsream (most neoPixel products)
// NEO_KHZ800  800 khz bitstream

uint32_t red = strip.Color(255, 0, 0);
uint32_t orange = strip.Color(255, 127, 0);
uint32_t yellow = strip.Color(255, 255, 0);
uint32_t green = strip.Color(0, 255, 0);
uint32_t blue = strip.Color(0, 0, 255);
uint32_t purp = strip.Color(120, 0, 255);
uint32_t turq = strip.Color(64, 210, 210);
uint32_t blank = strip.Color(0, 0, 0);

uint32_t colors[7] = {red, orange, yellow, green, turq, blue, purp};

int color_index = 0;


void setup()                    
{
   //capsense.set_CS_AutocaL_Millis(0xFFFFFFFF);     // turn off autocalibrate on channel 1 - just as an example
   serial.begin(9600);
   pinMode(cap_pin_in, INPUT);
   pinMode(cap_pin_out, OUTPUT);
   pinMode(outputPin, OUTPUT);
   digitalWrite(outputPin, LOW);

   vector.setStorage(storage_array);

  

    strip.begin();            // init NeoPixel strip

    
           // turns off all the pixels, clears anything from prev program 
    strip.setBrightness(100);  // set brightness to about 1/5

    for (int i = 0; i < LED_COUNT; i++) // start off with blank strip
    {
     strip.setPixelColor(i, blank);
    }

    
    strip.show();  
}



void loop()                    
{

  

    // populate vector
    
    long total = 0;
    long average = 0;

    for (int i = 0; i < indAverage; i++)
    {
      long start = millis();
      long total1 =  capsense.capacitiveSensor(30);
      total += total1;
    }
//
    average = total / indAverage;
    serial.println(counter);
    serial.println(average);                  // print sensor output 1
    serial.println(averageCalculated);
    serial.println(" ");
    
    while (vector.size() < VECTOR_SIZE)
    {
      vector.push_back(average);
      //serial.print("adding ");
      //serial.print(average);
      //serial.println(" to vector");
      averageTotal += average;
    }
      // once counter gets to 50 push an element and take new average
    if (counter == 40)
    {
     
      //serial.println("resetting");
 
      averageTotal -= vector[0];
      vector.remove(0);
      
      averageTotal += average;
      vector.push_back(average);
      
      //..serial.println("new vector");
      //serial.println(vector);
  
      
      counter = 0;
    }
    averageCalculated = averageTotal / VECTOR_SIZE;
   
    

    if (average > averageCalculated + 150)
    {
      digitalWrite(outputPin, HIGH);
      for (int i = 0; i < LED_COUNT; i++)
      {
        strip.setPixelColor(i, colors[color_index]);
      }
      strip.show();


      color_index += 1;
      if (color_index > 6)
      {
        color_index = 0;
      }
 
      delay(50);
      for (int i = 0; i < LED_COUNT; i++)
      {
        strip.setPixelColor(i, blank);
      }
      strip.show();
      digitalWrite(outputPin, LOW);



    }
 

   counter += 1;
                              // arbitrary delay to limit data to serial port 
}
